#include <InputServerFilter.h>
#include <Point.h>
#include <Rect.h>
#include <Locker.h>

#include "Preferences.h"

class EasyMoveFilter : public BInputServerFilter
{
	public:
		EasyMoveFilter();
		virtual ~EasyMoveFilter();
		virtual filter_result Filter(BMessage *message, BList *outList);
		virtual status_t InitCheck();
		
	private:
		void GetActiveWindow();
		void MoveWinBy(const BPoint &point);
		void MoveWinToWorkspace(int32 oldWS, int32 newWS);
		
		static status_t UpdateThreadFunc(void *cookie);
		
		BMessenger *win_msgr;
		int32 win_num;
		
		int32 buttons;
		int32 modifiers;
		
		BPoint oldPos;
		int32 oldWorkspace;
		
		status_t init;
		
		Preferences prefs;
		thread_id updateThread;
};
