#include <Window.h>

#include "Preferences.h"

class BView;
class ModifierView;

class SettingsWin : public BWindow
{
	public:
		SettingsWin();
		~SettingsWin();
		virtual void MessageReceived(BMessage *message);
		virtual bool QuitRequested();
		
	private:
		void SendUpdateMessage();
		
		BView *bg;
		
		struct MaskListType
		{
			uint32 mask;
			char *label;
		};
		
		static const MaskListType ModifierList[];
		static const int32 NbModifiers;
		ModifierView **mModifierViewList;
		
		static const MaskListType ButtonList[];
		static const int32 NbButtons;
		ModifierView **mButtonViewList;
		
		Preferences mPrefs;
		
		static const uint32 MODIFIER_CHANGED='mdch';
		static const uint32 BUTTON_CHANGED  ='btch';
};
